package betterwithmods.module.tweaks;

import betterwithmods.common.BWMItems;
import betterwithmods.common.entity.EntityShearedCreeper;
import betterwithmods.module.Feature;
import betterwithmods.util.InvUtils;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.monster.EntityCreeper;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemShears;
import net.minecraft.item.ItemStack;
import net.minecraft.util.DamageSource;
import net.minecraft.util.SoundCategory;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

/**
 * Created by tyler on 4/20/17.
 */
public class CreeperShearing extends Feature {

    @SubscribeEvent
    public void shearCreeper(PlayerInteractEvent.EntityInteractSpecific e) {
        if (e.getTarget() instanceof EntityLivingBase) {
            EntityLivingBase creeper = (EntityLivingBase) e.getTarget();
            if (creeper instanceof EntityCreeper) {
                if (e.getSide().isServer() && creeper.func_70089_S() && !e.getItemStack().func_190926_b()) {
                    Item item = e.getItemStack().func_77973_b();
                    if (item instanceof ItemShears) {
                        e.getEntityPlayer().func_184811_cZ().func_185145_a(item, 20);
                        InvUtils.ejectStack(e.getWorld(), creeper.field_70165_t, creeper.field_70163_u, creeper.field_70161_v, new ItemStack(BWMItems.CREEPER_OYSTER));
                        EntityShearedCreeper shearedCreeper = new EntityShearedCreeper(e.getWorld());
                        creeper.func_70097_a(new DamageSource(""), 0);
                        copyEntityInfo(creeper, shearedCreeper);
                        e.getWorld().func_184148_a(null, shearedCreeper.field_70165_t, shearedCreeper.field_70163_u, shearedCreeper.field_70161_v, SoundEvents.field_187882_fq, SoundCategory.HOSTILE, 1, 0.3F);
                        e.getWorld().func_184148_a(null, shearedCreeper.field_70165_t, shearedCreeper.field_70163_u, shearedCreeper.field_70161_v, SoundEvents.field_187763_eJ, SoundCategory.HOSTILE, 1, 1F);
                        creeper.func_70106_y();
                        e.getWorld().func_72838_d(shearedCreeper);
                    }
                }
            }
        }
    }

    private void copyEntityInfo(EntityLivingBase copyFrom, EntityLivingBase copyTo) {
        copyTo.func_70606_j(copyFrom.func_110143_aJ());
        copyTo.func_70080_a(copyFrom.field_70165_t, copyFrom.field_70163_u, copyFrom.field_70161_v, copyFrom.field_70177_z, copyFrom.field_70125_A);
        copyTo.func_70034_d(copyFrom.func_70079_am());
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @Override
    public String getFeatureDescription() {
        return "Shearing a Creeper will removes its ability to explode, making him very sad";
    }
}
